<template>
  <v-select
    v-model="selectedRate"
    label="Тариф"
    :items="rates"
    :loading="isLoading"
    hide-details
    return-object
    @update:focused="onFocus"
  >
    <template #prepend-item>
      <section class="p-3">
        <v-text-field
          :clearable="!isLoading"
          flat
          variant="solo-filled"
          prepend-inner-icon="mdi-magnify"
          placeholder="Поиск"
          type="input"
          hide-details
          density="comfortable"
          @input="onSearchInput"
          @click:clear="term = ''"
        >
          <template #append-inner>
            <v-btn
              v-tooltip:left="{ text: `Минимум символов: ${MIN_SEARCH_TERM_LENGTH}`, openOnClick: true }"
              icon="mdi-shield-alert-outline"
              variant="plain"
              size="small"
              :ripple="false"
            />
          </template>
        </v-text-field>
      </section>
    </template>

    <template #item="{ item, props }">
      <!--Leave title empty to fix vue warnings-->
      <v-list-item
        v-bind="props"
        title=""
        class="py-2"
      >
        <template #title>
          <section class="flex items-center gap-2">
            <v-icon icon="mdi-cash" />

            <section>
              {{ item.value.name }}
            </section>
          </section>
        </template>

        <template #subtitle>
          <section class="mt-2 ml-6">
            <ProfitDisplay
              :value="item.value.profit"
              mode="chip"
            />
          </section>
        </template>
      </v-list-item>
    </template>

    <template #selection="{ item }">
      <section class="flex items-center gap-2">
        <v-icon icon="mdi-cash" />

        <section>
          <span>
            {{ item.value.name }} -
          </span>

          <span class="text-gray-500">
            <ProfitDisplay
              :value="item.value.profit"
              mode="plain"
            />
          </span>

          <span
            v-if="item.value.profit > 0"
            class="text-gray-500"
          >
            / чел.
          </span>
        </section>
      </section>
    </template>

    <template #append-item>
      <InlineLoadingIndicator
        v-if="isLoading"
        embedded
      />

      <div
        v-intersect="onFullyScrolled"
        class="h-4"
      />
    </template>

    <template #no-data>
      <EmptyState
        v-if="!isLoading && !rates.length"
        embedded
      />
    </template>
  </v-select>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';
import { VSelect, VTextField } from 'vuetify/components';

import { HttpClient } from '@/http';
import { usePagination } from '@/composables';

import { MIN_SEARCH_TERM_LENGTH } from '@/declarations';
import { debounce } from '@/utils';

import EmptyState from '@/components/layout/EmptyState.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';
import InlineLoadingIndicator from '@/components/layout/InlineLoadingIndicator.vue';

defineProps<{ modelValue: IRate | null }>();
const emit = defineEmits(['update:modelValue']);

const RATES_LIST_SIZE = 10;

const pagination = usePagination({ size: RATES_LIST_SIZE });

const rates = ref<IRate[]>([]);
const selectedRate = ref<IRate | null>(null);

const term = ref('');
const isLoading = ref(false);

const onFocus = async (isFocused: boolean) => {
  if (!isFocused || isLoading.value) {
    return;
  }

  await fetchData({ reset: true });
};

const onSearchInput = debounce(500, (event: InputEvent) => {
  const target = event.target as HTMLInputElement;
  const value = target.value;

  const currentTerm = value?.trim() ?? '';

  if (currentTerm && currentTerm.length < MIN_SEARCH_TERM_LENGTH) {
    return;
  }

  term.value = currentTerm;
});

const onFullyScrolled = (isIntersecting: boolean) => {
  const isDataLoaded = (
    rates.value.length < RATES_LIST_SIZE
  );

  if (!isIntersecting || isDataLoaded) {
    return;
  }

  fetchData({ reset: false });
};

const fetchData = async (options: Partial<PageFetchDataOptions>) => {
  isLoading.value = true;

  if (options.reset) pagination.resetPage();
  if (!options.reset) pagination.nextPage();

  const response = await HttpClient.get<IRate[]>('/v1/rates', {
    params: {
      limit: RATES_LIST_SIZE,
      offset: pagination.offset.value,
      ...(term.value && { term: term.value }),
    },
  });

  isLoading.value = false;

  if (!response.data.values) {
    return;
  }

  rates.value = options.reset
    ? response.data.values
    : [...rates.value, ...response.data.values];
};

watch(term, () => fetchData({ reset: true }));
watch(selectedRate, value => emit('update:modelValue', value));
</script>